<template>
  <div>
    <v-row dense>
      <GCol cols="12">
        <div class="mt-4">
          <DccLocalizedTextBlock
            v-model="value.name"
            i18n="dcc.measurementResults.resultType.name"
            validate="required"
          />
        </div>
      </GCol>
      <GCol cols="12">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol>
        <v-alert
          v-if="!value.data.quantity && !value.data.list"
          color="warning"
          icon="warning"
        >
          {{ $t("dcc.measurementResults.noQuantityOrListWarning") }}
        </v-alert>
      </GCol>
    </v-row>
    <RichContent
      v-if="value.description"
      v-model="value.description"
      i18n="dcc.common.richContentType.description.title"
      optional
      level="second"
      @delete="deleteRichContent()"
    />
    <QuantityList
      v-if="value.data.quantity"
      v-model="value.data"
      :card="true"
      optional
      level="second"
      class="mt-4"
      @delete="deleteQuantity()"
    />
    <template v-if="value.data && value.data.list">
      <DccList
        v-for="(_, index) in value.data.list"
        :key="index"
        v-model="value.data.list[index]"
        optional
        class="mt-4"
        :class="index + '_' + 'list'"
        :index-path="index.toString()"
        :depth="1"
        @delete="deleteList(index)"
      />
    </template>
  </div>
</template>

<script>
import { RichContentType, ListType } from "@d-ptb/dcc-js";
import { insertIf } from "assets/util/general";
import { validatableMixin } from "../../Mixins/validatableMixin";
import DccLocalizedTextBlock from "../../App/Form/XML/DccLocalizedTextBlock";
import RichContent from "~/components/DCC/Common/RichContent";
import GTextField from "~/components/App/Form/gTextField";
import DccList from "~/components/DCC/Common/DccList";
import QuantityList from "~/components/DCC/Common/QuantityList";
import GCol from "~/components/App/Common/GCol";

export default {
  name: "DccResult",
  components: {
    GCol,
    DccList,
    GTextField,
    DccLocalizedTextBlock,
    RichContent,
    QuantityList,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    updateAvailableElements: Function,
  },
  computed: {
    availableElements() {
      return ["listType", "quantityType", "richContentType"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(
          this.value.data && this.value.data.quantity,
          "quantityType"
        ),
        ...insertIf(this.value.description, "richContentType"),
      ];
    },
    quantityIsPresent() {
      return !!(
        (this.value.data.quantity && this.value.data.quantity.length > 0) ||
        (this.value.data.list && this.value.data.list[0])
      );
    },
    customRules() {
      return [() => this.quantityIsPresent];
    },
  },
  watch: {
    "value.data"() {
      this.validate();
    },
    "value.data.quantity"() {
      this.validate();
    },
    "value.data.list"() {
      this.validate();
    },
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "listType":
          this.value.data && this.value.data.list
            ? this.value.data.list.push(new ListType())
            : this.$set(this.value.data, "list", [new ListType()]);
          // scroll to new list element
          this.$nextTick(() => {
            const lists = document.getElementsByClassName(
              this.value.data.list.length - 1 + "_" + "list"
            );
            lists[lists.length - 1].scrollIntoView({ behavior: "smooth" });
          });
          break;
        case "quantityType":
          this.$set(this.value.data, "quantity", []);
          break;
        case "richContentType":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
    deleteQuantity() {
      confirm(
        this.$t("dcc.measurementResults.resultType.quantity.confirmRemove")
      ) && this.$delete(this.value.data, "quantity");
    },
    deleteList(index) {
      confirm(
        this.$t("dcc.measurementResults.resultType.list.confirmRemove")
      ) &&
        (this.value.data.list.length > 1
          ? this.value.data.list.splice(index, 1)
          : this.$delete(this.value.data, "list"));
    },
  },
};
</script>
